// Rouslan Dimitrov 2011. This is free software - use it to learn or modify it to suit your needs.
#define _CRT_SECURE_NO_DEPRECATE
#include <stdio.h>
#include <string.h>
#include "..\synth\declarations.h"

char *header = 
	".global read_song_byte\n"
	".global read_song_word\n"
	".global wave_table1\n"
	".global wave_table2\n"
	".global song_data\n"
	"\n.text\n\n"
	"read_song_byte:\n"
	"	ldi	r30, lo8(song_data)\n"
	"	add	r30, r24\n"
	"	ldi	r31, hi8(song_data)\n"
	"	adc	r31, r25\n"
	"	lpm	r24, Z\n"
	"	ret\n\n"
	"read_song_word:\n"
	"	ldi	r30, lo8(song_data)\n"
	"	add	r30, r24\n"
	"	ldi	r31, hi8(song_data)\n"
	"	adc	r31, r25\n"
	"	lpm	r24, Z+\n"
	"	lpm	r25, Z\n"
	"	ret\n\n"
	"song_data:\n"
	"	.byte ";

char *wave1 = 
	"\n\n.data\n\n"
	"wave_table1:\n"
	"	.byte ";

char *wave2 = 
	"\n\nwave_table2:\n"
	"	.byte ";

int main(int argc, char *argv[])
{
	FILE *sad_file, *ass_file;
	char* file_ext;
	u32 sad_header;
	u8	waves[128];
	u8	byte;
	size_t i, song_len;

	if ( argc < 2 ) {
		puts("Usage:\n sad2ass sad_file\n");
		return E_USAGE;
	}

	if(!(file_ext = strstr(argv[1], ".sad"))) {
		puts("Input file should end in .sad\n");
		return E_USAGE;
	}

	if(!(sad_file = fopen(argv[1], "rb"))) {
		puts("Could not open sad file\n");
		return E_USAGE;
	}

	fseek(sad_file, 0, SEEK_END);
	song_len = ftell(sad_file) - 2*64 - 4;
	fseek(sad_file, 0, SEEK_SET);

	fread(&sad_header, 4, 1, sad_file);

	if(sad_header != *(u32*)"sad1")
	{
		puts(".sad file not valid\n");
		return E_USAGE;
	}

	fread(waves, 1, 128, sad_file);

	strcpy(file_ext, ".S");
	ass_file = fopen(argv[1], "wb");

	fwrite(header, 1, strlen(header), ass_file);	

	for(i=0; i<song_len; i++) {
		char number[8];
		u32	number32;
		fread(&byte, 1, 1, sad_file);
		number32 = byte;
		sprintf(number, "0x%02x, ", number32);
		fwrite(number, 1, 6, ass_file);
		if((i&7) == 7 && i != song_len-1 && i != 0) {
			fseek(ass_file, -2, SEEK_CUR); // Eat last comma
			fwrite("\n\t.byte ", 1, 8, ass_file);
		}
	}
	fseek(ass_file, -2, SEEK_CUR);
	fwrite(wave1, 1, strlen(wave1), ass_file);

	for(i=0; i<64; i+=1) {
		char number[8];
		u32	number32 = *(u32*)&waves[i];
		number32 &= 0xff;
		sprintf(number, "0x%02x, ", number32);
		fwrite(number, 1, 6, ass_file);
	}

	fseek(ass_file, -2, SEEK_CUR);
	fwrite(wave2, 1, strlen(wave2), ass_file);

	for(i=64; i<128; i+=1) {
		char number[8];
		u32	number32 = *(u32*)&waves[i];
		number32 &= 0xff;
		sprintf(number, "0x%02x, ", number32);
		fwrite(number, 1, 6, ass_file);
	}

	fseek(ass_file, -2, SEEK_CUR);
	fwrite("\n\n", 1, 2, ass_file);

	printf("%s written.\n", argv[1]);

	return E_OK;
}
